/* GCC */
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <algorithm>

using namespace std;
int n;
vector<string> names;
vector<vector<int> > rel(40, vector<int>(40, 0));
vector<bool> male(40, false);

void toNominative(string &a){
    int last=a.size()-1;
    if(a.size()==5 &&   (a[0]=='' || a[0]=='')
                   &&   (a[1]=='' || a[1]=='')
                   &&   (a[2]=='' || a[2]=='')
                   &&   (a[3]=='' || a[3]=='')
                   &&   (a[4]=='' || a[4]==''))
    {
        a.erase(last);
    } else if(a[last]==''){
        a[last]='';
    } else if(a[last]==''){
        a[last]='';
    } else if(a[last]==''){
        a[last]='';
    } else if(a[last]==''){
        a[last]='';
    } else if(a[last]==''){
        a[last]='';
    } else if(a[last]==''){
        a[last]='';
    } else a.erase(last);
}

void toGenetive(string &a){
    int last=a.size()-1;
    if(a.size()==4 &&   (a[0]=='' || a[0]=='')
                   &&   (a[1]=='' || a[1]=='')
                   &&   (a[2]=='' || a[2]=='')
                   &&   (a[3]=='' || a[3]==''))
    {
        a+='';
    } else if(a[last]=='' || a[last]==''){
        a[last]='';
    }  else if(a[last]=='' || a[last]==''){
        a[last]='';
    }  else if(a[last]=='' || a[last]==''){
        a[last]='';
    //}  else if(a[last]=='' || a[last]==''){
    //    a[last]='';
    }  else a+='';
}

void endingToLower(string &a){
    int last=a.size()-1;
    if(a[last]=='') a[last]='';
    else if(a[last]=='') a[last]='';
    else if(a[last]=='') a[last]='';
}

int getNameNum(string a){
    int i;
    for(i=0; i<names.size(); i++){
        if(names[i]==a) return i;
    }
    names.push_back(a);
    return i;
}

void readData(){
    freopen("family.in", "r", stdin);

    string s, s1, s2, s3;
    getline(cin, s1);
    getline(cin, s2);
    getNameNum(s1);
    getNameNum(s2);

    int n1, n2;

    while(getline(cin, s)){
        stringstream ss(s);
        ss>>s1>>s2>>s2>>s3;
        toNominative(s3);
        n1=getNameNum(s1);
        n2=getNameNum(s3);
        if(s2==""){
            rel[n1][n2]=3;
            male[n1]=true;
            if(male[n2]) rel[n2][n1]=1;
            else rel[n2][n1]=2;
        }
        if(s2==""){
            rel[n1][n2]=4;
            male[n1]=false;
            if(male[n2]) rel[n2][n1]=1;
            else rel[n2][n1]=2;
        }
        if(s2==""){
            rel[n1][n2]=6;
            male[n1]=false;
            rel[n2][n1]=5;
            male[n2]=true;
        }
    }
    n=names.size();

    fclose(stdin);
}

void solve(){
    bool changed=true;
    while(rel[0][1]==0 && changed){
        changed=false;
        for(int i=0; i<n; i++){
            for(int z=0; z<n; z++){
                if(i==z || rel[i][z]!=0) continue;
                for(int k=0; k<n; k++){
                    if(k==i || k==z || rel[i][k]==0 || rel[k][z]==0) continue;

                    if(rel[i][k]==5 && (rel[k][z]==2 || rel[k][z]==2)) rel[i][z]=1; else
                    if(rel[i][k]==6 && (rel[k][z]==1 || rel[k][z]==1)) rel[i][z]=2; else
                    if(rel[i][k]==3 && (rel[k][z]==5 || rel[k][z]==6)) rel[i][z]=3; else
                    if(rel[i][k]==4 && (rel[k][z]==5 || rel[k][z]==6)) rel[i][z]=4; else
                    if(rel[i][k]==1 && (rel[k][z]==3 || rel[k][z]==4)) rel[i][z]=5; else
                    if(rel[i][k]==2 && (rel[k][z]==3 || rel[k][z]==4)) rel[i][z]=6; else
                    if(rel[i][k]==1 && (rel[k][z]==1 || rel[k][z]==2)) rel[i][z]=7; else
                    if(rel[i][k]==2 && (rel[k][z]==1 || rel[k][z]==2)) rel[i][z]=8; else
                    if(rel[i][k]==1 && (rel[k][z]==7 || rel[k][z]==8)) rel[i][z]=9; else
                    if(rel[i][k]==2 && (rel[k][z]==7 || rel[k][z]==8)) rel[i][z]=10; else
                    if(rel[i][k]==3 && (rel[k][z]==3 || rel[k][z]==4)) rel[i][z]=11; else
                    if(rel[i][k]==4 && (rel[k][z]==3 || rel[k][z]==4)) rel[i][z]=12; else
                    if(rel[i][k]==3 && (rel[k][z]==11 || rel[k][z]==12)) rel[i][z]=13; else
                    if(rel[i][k]==4 && (rel[k][z]==11 || rel[k][z]==12)) rel[i][z]=14; else
                    if(rel[i][k]==3 && (rel[k][z]==1 || rel[k][z]==2)) rel[i][z]=15; else
                    if(rel[i][k]==4 && (rel[k][z]==1 || rel[k][z]==2)) rel[i][z]=16; else
                    if(rel[i][k]==15 && rel[k][z]==1 || rel[i][k]==5 && rel[k][z]==18) rel[i][z]=17; else
                    if(rel[i][k]==16 && rel[k][z]==1 || rel[i][k]==6 && rel[k][z]==17) rel[i][z]=18; else
                    if(rel[i][k]==15 && rel[k][z]==2 || rel[i][k]==5 && rel[k][z]==20) rel[i][z]=19; else
                    if(rel[i][k]==16 && rel[k][z]==2 || rel[i][k]==6 && rel[k][z]==19) rel[i][z]=20; else
                    if(rel[i][k]==3 && (rel[k][z]==15 || rel[k][z]==16)) rel[i][z]=21; else
                    if(rel[i][k]==4 && (rel[k][z]==15 || rel[k][z]==16)) rel[i][z]=22; else
                    if(rel[i][k]==3 && (rel[k][z]==17 || rel[k][z]==18 || rel[k][z]==19 || rel[k][z]==20)) rel[i][z]=23; else
                    if(rel[i][k]==4 && (rel[k][z]==17 || rel[k][z]==18 || rel[k][z]==19 || rel[k][z]==20)) rel[i][z]=24; else
                    if(rel[i][k]==13 && (rel[k][z]==9 || rel[k][z]==10)) rel[i][z]=25; else
                    if(rel[i][k]==14 && (rel[k][z]==9 || rel[k][z]==10)) rel[i][z]=26; else
                    if(rel[i][k]==3 && (rel[k][z]==21 || rel[k][z]==22)) rel[i][z]=27; else
                    if(rel[i][k]==4 && (rel[k][z]==21 || rel[k][z]==22)) rel[i][z]=28; else
                    if(rel[i][k]==1 && rel[k][z]==5) rel[i][z]=29; else
                    if(rel[i][k]==2 && rel[k][z]==5) rel[i][z]=30; else
                    if(rel[i][k]==1 && rel[k][z]==6) rel[i][z]=31; else
                    if(rel[i][k]==2 && rel[k][z]==6) rel[i][z]=32; else
                    //33
                    //34
                    if(rel[i][k]==15 && rel[k][z]==5) rel[i][z]=35; else
                    if(rel[i][k]==6 && rel[k][z]==35) rel[i][z]=36; else
                    if(rel[i][k]==16 && rel[k][z]==5) rel[i][z]=37; else
                    if(rel[i][k]==5 && rel[k][z]==4) rel[i][z]=38; else
                    if(rel[i][k]==6 && rel[k][z]==3) rel[i][z]=39; else
                    if(rel[i][k]==15 && rel[k][z]==6 || rel[i][k]==5 && rel[k][z]==41) rel[i][z]=40; else
                    if(rel[i][k]==16 && rel[k][z]==6 || rel[i][k]==6 && rel[k][z]==40) rel[i][z]=41; else
                    if(rel[i][k]==5 && rel[k][z]==16) rel[i][z]=42; else
                    if(rel[i][k]==6 && rel[k][z]==15) rel[i][z]=43;

                    if(rel[i][z]!=0) {
                        changed=true;
                        break;
                    }
                }
            }
        }
    }
    if(rel[0][1]==0){
        if(male[0]) rel[0][1]=33;
        else rel[0][1]=34;
    }
}

void fileOut(){
    freopen("family.out", "w", stdout);

    toGenetive(names[1]);
    endingToLower(names[0]);
    string r;

    if(rel[0][1]==1) r=""; else
    if(rel[0][1]==2) r=""; else
    if(rel[0][1]==3) r=""; else
    if(rel[0][1]==4) r=""; else
    if(rel[0][1]==5) r=""; else
    if(rel[0][1]==6) r=""; else
    if(rel[0][1]==7) r=""; else
    if(rel[0][1]==8) r=""; else
    if(rel[0][1]==9) r=""; else
    if(rel[0][1]==10) r=""; else
    if(rel[0][1]==11) r=""; else
    if(rel[0][1]==12) r=""; else
    if(rel[0][1]==13) r=""; else
    if(rel[0][1]==14) r=""; else
    if(rel[0][1]==15) r=""; else
    if(rel[0][1]==16) r=""; else
    if(rel[0][1]==17) r=""; else
    if(rel[0][1]==18) r=""; else
    if(rel[0][1]==19) r=""; else
    if(rel[0][1]==20) r=""; else
    if(rel[0][1]==21) r=""; else
    if(rel[0][1]==22) r=""; else
    if(rel[0][1]==23) r=" "; else
    if(rel[0][1]==24) r=" "; else
    if(rel[0][1]==25) r=" "; else
    if(rel[0][1]==26) r=" "; else
    if(rel[0][1]==27) r=" "; else
    if(rel[0][1]==28) r=" "; else
    if(rel[0][1]==29) r=""; else
    if(rel[0][1]==30) r=""; else
    if(rel[0][1]==31) r=""; else
    if(rel[0][1]==32) r=""; else
    if(rel[0][1]==33) r=""; else
    if(rel[0][1]==34) r=""; else
    if(rel[0][1]==35) r=""; else
    if(rel[0][1]==36) r=""; else
    if(rel[0][1]==37) r=""; else
    if(rel[0][1]==38) r=""; else
    if(rel[0][1]==39) r=""; else
    if(rel[0][1]==40) r=""; else
    if(rel[0][1]==41) r=""; else
    if(rel[0][1]==42) r=""; else
    if(rel[0][1]==43) r="";
    cout<<names[0]<<" - "<<r<<' '<<names[1]<<endl;

    fclose(stdout);
}

int main(){
    readData();
    solve();
    fileOut();
    return 0;
}
