#include<iostream>
#include<fstream>

using namespace std;

string fromR(string name){
    if(name.size() == 5 &&
      (name[0] == '' || name[0] == '') &&
      (name[1] == '' || name[1] == '') &&
      (name[2] == '' || name[2] == '') &&
      (name[3] == '' || name[3] == '')) return name.substr(0, name.size()-1);
    char last = name[name.size()-1];
    if(last == '') return name.substr(0, name.size()-1) + '';
    if(last == '') return name.substr(0, name.size()-1) + '';
    if(last == '') return name.substr(0, name.size()-1) + '';
    if(last == '') return name.substr(0, name.size()-1) + '';
    if(last == '') return name.substr(0, name.size()-1) + '';
    if(last == '') return name.substr(0, name.size()-1) + '';
    return name.substr(0, name.size()-1);
}

string toR(string name){
    if(name.size() == 4 &&
      (name[0] == '' || name[0] == '') &&
      (name[1] == '' || name[1] == '') &&
      (name[2] == '' || name[2] == '') &&
      (name[3] == '' || name[3] == '')) return name + '';
    char last = name[name.size()-1];
    if(last == '') return name.substr(0, name.size()-1) + '';
    if(last == '') return name.substr(0, name.size()-1) + '';
    if(last == '') return name.substr(0, name.size()-1) + '';
    if(last == '') return name.substr(0, name.size()-1) + '';
    if(last == '') return name.substr(0, name.size()-1) + '';
    if(last == '') return name.substr(0, name.size()-1) + '';
    return name + '';
}

int n, contact[50][50];
string people[50];
bool floor[50];

int main(){
    setlocale(LC_CTYPE, "ukr");
    ifstream in;
    in.open("family.in");
    ofstream out;
    out.open("family.out");
    string name;
    in >> people[0] >> people[1];
    n = 2;
    string people_1, people_2, con;
    int index_1, index_2;
    while(in >> people_1){
        in >> con >> con >> people_2;
        people_2 = fromR(people_2);
        for(index_1 = 0; index_1 < n; ++index_1)
            if(people[index_1] == people_1) break;
        if(index_1 == n)
            people[n++] = people_1;
        for(index_2 = 0; index_2 < n; ++index_2)
            if(people[index_2] == people_2) break;
        if(index_2 == n)
            people[n++] = people_2;
        if(con == ""){
            contact[index_1][index_2] = 6;
            contact[index_2][index_1] = 5;
            floor[index_2] = true;
        }
        else if(con == ""){
            contact[index_1][index_2] = 3;
            floor[index_1] = true;
            if(floor[index_2])
                contact[index_2][index_1] = 1;
            else
                contact[index_2][index_1] = 2;
        }
        else{
            contact[index_1][index_2] = 4;
            if(floor[index_2])
                contact[index_2][index_1] = 1;
            else
                contact[index_2][index_1] = 2;
        }
    }
    for(int i = 0; i < n; ++i)
    for(int j = 0; j < n; ++j){
        if(i == j) continue;
        if(floor[i] == true && contact[i][j] == 2)
            contact[i][j] = 1;
    }
    bool updated = true;
    while(updated){
        updated = false;
        for(int i = 0; i < n; ++i)
        for(int j = 0; j < n; ++j)
        for(int k = 0; k < n; ++k){
            if(i == j || i == k || j == k) continue;
            if(contact[i][j] != 0 || contact[i][k] == 0 || contact[k][j] == 0) continue;
            int ik = contact[i][k], kj = contact[k][j];

            if(ik == 5 && kj == 2) contact[i][j] = 1; else
            if(ik == 6 && kj == 1) contact[i][j] = 2; else
            if(ik == 3 && (kj == 5 || kj == 6)) contact[i][j] = 3; else
            if(ik == 4 && (kj == 5 || kj == 6)) contact[i][j] = 4; else
            if(ik == 1 && (kj == 3 || kj == 4)) contact[i][j] = 5; else
            if(ik == 2 && (kj == 3 || kj == 4)) contact[i][j] = 6; else
            if(ik == 1 && (kj == 1 || kj == 2)) contact[i][j] = 7; else
            if(ik == 2 && (kj == 1 || kj == 2)) contact[i][j] = 8; else
            if(ik == 1 && (kj == 7 || kj == 8)) contact[i][j] = 9; else
            if(ik == 2 && (kj == 7 || kj == 8)) contact[i][j] = 10; else
            if(ik == 3 && (kj == 3 || kj == 4)) contact[i][j] = 11; else
            if(ik == 4 && (kj == 3 || kj == 4)) contact[i][j] = 12; else
            if(ik == 3 && (kj == 11 || kj == 12)) contact[i][j] = 13; else
            if(ik == 4 && (kj == 11 || kj == 12)) contact[i][j] = 14; else
            if(ik == 3 && (kj == 1 || kj == 2)) contact[i][j] = 15; else
            if(ik == 4 && (kj == 1 || kj == 2)) contact[i][j] = 16; else
            if(kj == 1 && (ik == 15 || ik == 42)) contact[i][j] = 17; else
            if(kj == 1 && (ik == 16 || ik == 43)) contact[i][j] = 18; else
            if(kj == 2 && (ik == 15 || ik == 42)) contact[i][j] = 19; else
            if(kj == 2 && (ik == 16 || ik == 43)) contact[i][j] = 20; else
            if(ik == 3 && (kj == 15 || kj == 16)) contact[i][j] = 21; else
            if(ik == 4 && (kj == 15 || kj == 16)) contact[i][j] = 22; else
            if(ik == 3 && (kj == 17 || kj == 18 || kj == 19 || kj == 20)) contact[i][j] = 23; else
            if(ik == 4 && (kj == 17 || kj == 18 || kj == 19 || kj == 20)) contact[i][j] = 24; else
            if(ik == 13 && (kj == 9 || kj == 10)) contact[i][j] = 25; else
            if(ik == 14 && (kj == 9 || kj == 10)) contact[i][j] = 26; else
            if(ik == 3 && (kj == 21 || kj == 22)) contact[i][j] = 27; else
            if(ik == 4 && (kj == 21 || kj == 22)) contact[i][j] = 28; else
            if(ik == 1 && kj == 5) contact[i][j] = 29; else
            if(ik == 2 && kj == 5) contact[i][j] = 30; else
            if(ik == 1 && kj == 6) contact[i][j] = 31; else
            if(ik == 2 && kj == 6) contact[i][j] = 32; else
            // svat - 33
            // svaha - 34
            if(ik == 15 && kj == 5) contact[i][j] = 35; else
            if(ik == 6 && kj == 35) contact[i][j] = 36; else
            if(ik == 16 && kj == 5) contact[i][j] = 37; else
            if(ik == 5 && kj == 4) contact[i][j] = 38; else
            if(ik == 6 && kj == 3) contact[i][j] = 39; else
            if(kj == 6 && (ik == 15 || ik == 42)) contact[i][j] = 40; else
            if(kj == 6 && (ik == 16 || ik == 43)) contact[i][j] = 41; else
            if(ik == 5 && kj == 16) contact[i][j] = 42; else
            if(ik == 6 && kj == 15) contact[i][j] = 43;

            if(contact[i][j]) updated = true;
        }
    }
    if(contact[0][1] == 0)
        contact[0][1] = (floor[0] ? 33 : 34);
    int ans = contact[0][1];
    if(ans == 1) con = ""; else
    if(ans == 2) con = ""; else
    if(ans == 3) con = ""; else
    if(ans == 4) con = ""; else
    if(ans == 5) con = ""; else
    if(ans == 6) con = ""; else
    if(ans == 7) con = ""; else
    if(ans == 8) con = ""; else
    if(ans == 9) con = ""; else
    if(ans == 10) con = ""; else
    if(ans == 11) con = ""; else
    if(ans == 12) con = ""; else
    if(ans == 13) con = ""; else
    if(ans == 14) con = ""; else
    if(ans == 15) con = ""; else
    if(ans == 16) con = ""; else
    if(ans == 17) con = ""; else
    if(ans == 18) con = ""; else
    if(ans == 19) con = ""; else
    if(ans == 20) con = ""; else
    if(ans == 21) con = ""; else
    if(ans == 22) con = ""; else
    if(ans == 23) con = " "; else
    if(ans == 24) con = " "; else
    if(ans == 25) con = " "; else
    if(ans == 26) con = " "; else
    if(ans == 27) con = " "; else
    if(ans == 28) con = " "; else
    if(ans == 29) con = ""; else
    if(ans == 30) con = ""; else
    if(ans == 31) con = ""; else
    if(ans == 32) con = ""; else
    if(ans == 33) con = ""; else
    if(ans == 34) con = ""; else
    if(ans == 35) con = ""; else
    if(ans == 36) con = ""; else
    if(ans == 37) con = ""; else
    if(ans == 38) con = ""; else
    if(ans == 39) con = ""; else
    if(ans == 40) con = ""; else
    if(ans == 41) con = ""; else
    if(ans == 42) con = ""; else
    if(ans == 43) con = "";
    out << people[0] << " - " << con << ' ' << toR(people[1]) << endl;
}
