#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>

using namespace std;

int main(){
    freopen("subseq.in","r",stdin);
    freopen("subseq.out","w",stdout);
    int n, m;
    cin >> n;
    int* a = new int[n+1];
    for(int i = 1; i <= n; i++) cin >> a[i];
    cin >> m;
    int* b = new int[m+1];
    for(int i = 1; i <= m; i++) cin >> b[i];
    int** dp = new int* [2];
    dp[0] = new int [m+1];
    dp[1] = new int [m+1];
    for(int i = 0; i <= m; i++) dp[0][i] = 0;
    dp[1][0] = 0;
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= m; j++){
            if(a[i] == b[j])
                dp[1][j] = dp[0][j-1]+1;
            else
                dp[1][j] = max(dp[1][j-1],dp[0][j]);
        }
        swap(dp[0],dp[1]);
    }
    cout << dp[0][m] << "\n";
    return 0;
}
