#include <cstdio>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <map>

using namespace std;

struct link{
    string s, tp, f, rid1, rid2, orig;
};

string Rodov(string S){
    if (S[S.size()-1] == '') S[S.size()-1] = '';
    else if (S[S.size()-1] == '') S[S.size()-1] = '';
    else if (S[S.size()-1] == '') S[S.size()-1] = '';
    else if (S[S.size()-1] == '') S[S.size()-1] = '';
    else if (S[S.size()-1] == '') S[S.size()-1] = '';
    else if (S[S.size()-1] == '') S[S.size()-1] = '';
    else {S.resize(S.size()+1); S[S.size()-1] = '';}

    return S;
}

int main(){
    freopen("family.in", "r", stdin);
    freopen("family.out", "w", stdout);

    vector <string> FamIn;
    vector <link> Fam;
    string Name1, Name2;
    char buf[256];
    map <string , int> Sviaz;

    gets(buf); Name1 = buf;
    gets(buf); Name2 = buf;

    while (gets(buf)) {
        FamIn.push_back(buf);
    }

    while (FamIn.back().size() < 3) FamIn.pop_back();
    Fam.resize(FamIn.size());

    for (int i = 0; i<Fam.size(); i++){
        Fam[i].s = Fam[i].tp = Fam[i].f = FamIn[i];

        for (int j = 0; j<Fam[i].s.size(); j++) if (Fam[i].s[j] == ' '){
           Fam[i].s.erase(Fam[i].s.begin() + j, Fam[i].s.end());
            break;
        }

        Fam[i].tp.erase(Fam[i].tp.begin(), Fam[i].tp.begin() + Fam[i].s.size() + 3);
        Fam[i].f.erase(Fam[i].f.begin(), Fam[i].f.begin() + Fam[i].s.size() + 3);

        for (int j = 0; j<Fam[i].tp.size(); j++) if (Fam[i].tp[j] == ' '){
           Fam[i].tp.erase(Fam[i].tp.begin() + j, Fam[i].tp.end());
            break;
        }

        Fam[i].f.erase(Fam[i].f.begin(), Fam[i].f.begin() + Fam[i].tp.size() + 1);

        Fam[i].orig = Fam[i].f;

        if (Fam[i].f[Fam[i].f.size() - 1] == '') {Fam[i].f.resize(Fam[i].f.size() - 1); Fam[i].rid2 = "m"; }
        if (Fam[i].f[Fam[i].f.size() - 1] == '') {Fam[i].f.resize(Fam[i].f.size() - 1); Fam[i].rid2 = "m"; }
        if (Fam[i].f[Fam[i].f.size() - 1] == '') {Fam[i].f[Fam[i].f.size() - 1] = ''; Fam[i].rid2 = "m"; }
        if (Fam[i].f[Fam[i].f.size() - 1] == '') {Fam[i].f[Fam[i].f.size() - 1] = ''; Fam[i].rid2 = "m"; }
        if (Fam[i].f[Fam[i].f.size() - 1] == '') {Fam[i].f[Fam[i].f.size() - 1] = ''; Fam[i].rid2 = "w"; }
        if (Fam[i].f[Fam[i].f.size() - 1] == '') {Fam[i].f[Fam[i].f.size() - 1] = ''; Fam[i].rid2 = "w"; }
        if (Fam[i].f[Fam[i].f.size() - 1] == '') {Fam[i].f[Fam[i].f.size() - 1] = ''; Fam[i].rid2 = "w"; }
        if (Fam[i].f[Fam[i].f.size() - 1] == '') {Fam[i].f[Fam[i].f.size() - 1] = ''; Fam[i].rid2 = "w"; }

        if (Fam[i].tp == "") Fam[i].rid1 = "w";
        if (Fam[i].tp == "") Fam[i].rid1 = "w";
        if (Fam[i].tp == "") Fam[i].rid1 = "m";
/*
        for (int j = 0; j<Fam[i].s.size(); j++)    printf("%c", Fam[i].s[j]);
        for (int j = 0; j<Fam[i].rid1.size(); j++) printf("%c", Fam[i].rid1[j]); printf("\n");
        for (int j = 0; j<Fam[i].tp.size(); j++)   printf("%c", Fam[i].tp[j]); printf("\n");
        for (int j = 0; j<Fam[i].f.size(); j++)    printf("%c", Fam[i].f[j]);
        for (int j = 0; j<Fam[i].rid2.size(); j++) printf("%c", Fam[i].rid2[j]);printf("\n");
*/
    }

    for (int i = 0; i<Fam.size(); i++){
        if (Fam[i].s == Name1 && Fam[i].f == Name2) {
            for (int j = 0; j<Fam[i].s.size(); j++)    printf("%c", Fam[i].s[j]);
            printf(" - ");
            for (int j = 0; j<Fam[i].tp.size(); j++)   printf("%c", Fam[i].tp[j]);
            printf(" ");
            for (int j = 0; j<Fam[i].orig.size(); j++)    printf("%c", Fam[i].orig[j]);
            printf("\n");
            return 0;
        }

        if (Fam[i].s == Name2 && Fam[i].f == Name1) {
            for (int j = 0; j<Name1.size(); j++)    printf("%c", Name1[j]);
            printf(" - ");
            if (Fam[i].tp == "" || Fam[i].tp == "") if (Fam[i].rid2 == "m") printf(""); else printf("");
            if (Fam[i].tp == "") printf("");
            printf(" ");
            Name2 = Rodov(Name2);
            for (int j = 0; j<Name2.size(); j++)    printf("%c", Name2[j]);
            printf("\n");
            return 0;
        }
    }

    for (int i = 0; i<Fam.size(); i++) for (int j = 0; j<Fam.size(); j++) if (i != j){
        if (Fam[i].s == Name1){
            if (Fam[i].f == Fam[j].s && Fam[j].f == Name2){
                for (int j = 0; j<Name1.size(); j++) printf("%c", Name1[j]);
                printf(" - ");

                if (Fam[i].tp == "" && Fam[j].tp == "") printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") printf("??? ");
//                if (Fam[i].tp == "" && Fam[j].tp == "") printf("??? ");

                Name2 = Rodov(Name2);
                for (int j = 0; j<Name2.size(); j++)    printf("%c", Name2[j]);
                printf("\n");
            }
            if (Fam[i].f == Fam[j].f && Fam[j].s == Name2){
                for (int j = 0; j<Name1.size(); j++) printf("%c", Name1[j]);
                printf(" - ");

                if (Fam[i].tp == "" && Fam[j].tp == "") printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") printf("???");

                Name2 = Rodov(Name2);
                for (int j = 0; j<Name2.size(); j++)    printf("%c", Name2[j]);
                printf("\n");

            }
        }

        if (Fam[i].f == Name1){
            if (Fam[i].s == Fam[j].s && Fam[j].f == Name2){
                for (int j = 0; j<Name1.size(); j++) printf("%c", Name1[j]);
                printf(" - ");

                if (Fam[i].tp == "" && Fam[j].tp == "") if (Fam[i].rid2 == "m") printf(" "); else printf(" ");
                //if (Fam[i].tp == "" && Fam[j].tp == "") if (Fam[i].rid2 == "m") printf(" "); else printf(" ");
                //if (Fam[i].tp == "" && Fam[j].tp == "") if (Fam[i].rid2 == "m") printf(" "); else printf(" ");
                //if (Fam[i].tp == "" && Fam[j].tp == "") if (Fam[i].rid2 == "m") printf(" "); else printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") if (Fam[i].rid2 == "m") printf(" "); else printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") if (Fam[i].rid2 == "m") printf(" "); else printf(" ");
                //if (Fam[i].tp == "" && Fam[j].tp == "") if (Fam[i].rid2 == "m") printf(" "); else printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") printf(" ");
                //if (Fam[i].tp == "" && Fam[j].tp == "") if (Fam[i].rid2 == "m") printf(" "); else printf(" ");

                Name2 = Rodov(Name2);
                for (int j = 0; j<Name2.size(); j++)    printf("%c", Name2[j]);
                printf("\n");
            }

            if (Fam[i].s == Fam[j].s && Fam[j].f == Name2){
                for (int j = 0; j<Name1.size(); j++) printf("%c", Name1[j]);
                printf(" - ");

                if (Fam[i].tp == "" && Fam[j].tp == "") if (Fam[i].rid2 == "m") printf(" "); else printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") if (Fam[i].rid2 == "m") printf(" "); else printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") if (Fam[i].rid2 == "m") printf(" "); else printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") if (Fam[i].rid2 == "m") printf(" "); else printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") if (Fam[i].rid2 == "m") printf(" "); else printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") if (Fam[i].rid2 == "m") printf(" "); else printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") if (Fam[i].rid2 == "m") printf(" "); else printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") printf(" ");
                if (Fam[i].tp == "" && Fam[j].tp == "") if (Fam[i].rid2 == "m") printf(" "); else printf(" ");

                Name2 = Rodov(Name2);
                for (int j = 0; j<Name2.size(); j++)    printf("%c", Name2[j]);
                printf("\n");
            }
        }
    }



    return 0;
}
