/* GCC */

#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

int main(){
    freopen("subseq.in", "r", stdin);
    freopen("subseq.out", "w", stdout);

    int n, m;
    vector <int> Seq1, Seq2;
    vector <vector <int> > SubSeq;

    scanf ("%d", &n);
    Seq1.resize(n);
    for (int i = 0; i<n; i++) scanf("%d", &Seq1[i]);

    scanf("%d", &m);
    Seq2.resize(m);
    for (int i = 0; i<m; i++) scanf("%d", &Seq2[i]);

    SubSeq.resize(n+1);
    for (int i = 0; i <= n; i++){
        SubSeq[i].assign(m+1, 0);
        if (i > 0)
            for (int j = 1; j <= m; j++){
                if (Seq1[i-1] == Seq2[j-1]) SubSeq[i][j] = SubSeq[i - 1][j - 1] + 1;
                else SubSeq[i][j] = max(SubSeq[i-1][j], SubSeq[i][j-1]);
            }
    }

    printf("%d\n", SubSeq[n][m]);


    return 0;
}
