/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;
int k, l;
vector<int> kseq, lseq;

void readData(){
    freopen("subseq.in", "r", stdin);

    scanf("%d", &k);
    kseq=vector<int>(k+1);
    for(int i=1; i<=k; i++) scanf("%d", &kseq[i]);

    scanf("%d", &l);
    lseq=vector<int>(l+1);
    for(int i=1; i<=l; i++) scanf("%d", &lseq[i]);

    fclose(stdin);
}

void fileOut(){
    freopen("subseq.out", "w", stdout);

    vector< vector<int> > f(2, vector<int> (k+1, 0));
    int curr=0, prev=1;
    for(int i=1; i<=l; i++){
        for(int z=1; z<=k; z++){
            if(lseq[i]==kseq[z]) f[curr][z]=f[prev][z-1]+1;
            else f[curr][z]=max(f[prev][z], f[curr][z-1]);
        }
        swap(curr, prev);
    }
    printf("%d\n", f[prev][k]);

    fclose(stdout);
}

int main(){
    readData();
    fileOut();
    return 0;
}
