/* GCC */
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <sstream>
#include <cstdio>
#include <cmath>
#include <cstring>

#define fast ios_base::sync_with_stdio(false);cin.tie();cout.tie();
#define MAX 16000
using namespace std;

int main() {
    fast;
    freopen("subseq.in", "r", stdin);
    freopen("subseq.out", "w", stdout);

    int arr1[MAX], arr2[MAX];
    int n1, n2;

    cin >> n1;
    for(int i = 0; i < n1; ++i)
        cin >> arr1[i];

    cin >> n2;
    for(int i = 0; i < n2; ++i)
        cin >> arr2[i];

    vector<int> pr(n2, 0), cur(n2);

    for(int i = 0; i < n1; i++) {
        cur[0] = (arr1[i] == arr2[0] ? 1 : pr[0]);

        for(int j = 1; j < n2; j++)
            cur[j] = (arr1[i] == arr2[j] ? pr[j-1] + 1 : max(cur[j - 1], pr[j]));

        pr.swap(cur);
    }
    cout << pr[n2 - 1] << '\n';
}
